#include <pch.h>

SDL_GPUShader* ShaderLoad(SDL_GPUDevice* device, const char* filename, SDL_GPUShaderStage stage) {
    assert(device != NULL);

    FileData file = FileRead(filename);
    SDL_GPUShader* shader = SDL_CreateGPUShader(device,
        &(SDL_GPUShaderCreateInfo){
            .code = file.data,
            .code_size = file.length,
            .stage = stage,
            .format = SDL_GPU_SHADERFORMAT_SPIRV,
            .entrypoint = "main",
        });
    if(shader == NULL) {
        SDL_Log("Failed to create shader: %s", SDL_GetError());
    }

    return shader;
}
