#include "pch.h"

FileData FileRead(const char* filename) {
    FILE* f = fopen(filename, "r");
    if(f == NULL) {
        perror(filename);
        return (FileData){ 0 };
    }
    fseek(f, 0, SEEK_END);
    size_t length = ftell(f);
    rewind(f);

    uint8_t* buffer = malloc(length);
    if(buffer == NULL) {
        perror("Failed to allocate memory");
        return (FileData){ 0 };
    }
    size_t read_count = fread(buffer, sizeof(char), length, f);
    if(read_count != length) {
        perror("Failed to read entire file");
        return (FileData){ 0 };
    }

    return (FileData){
        .data = buffer,
        .length = length,
    };
}

void FileFree(FileData file) {
    free(file.data);
}
